function SetPlateActivated(isActivated)
    this:SetSharedObjectProperty("IsActivated", isActivated)  

    local trapTemplateId = this:GetObjVar("TrapTemplate")
    if (trapTemplateId ~= nil) then
        local trapObj = FindObjects(SearchTemplate(trapTemplateId,10)) 
        if( trapObj ~= nil) then
            for i,j in pairs(trapObj) do
                j:SetSharedObjectProperty("IsTriggered", isActivated)
            end
        end
    end
end

RegisterEventHandler(EventType.EnterView, "Activate", 
    function(user)
        SetPlateActivated(true)
        this:SetObjVar("Activated","true")
        local targetObject = GameObj(tonumber(this:GetObjVar("EnterObjectToMessage")))
        if(targetObject ~= nil) then
            targetObject:SendMessage(this:GetObjVar("SendMessageOnEnterView"))
            this:SetHue("FFFFFF")
            this:PlayObjectSound("ScrollPickup",false)
        end
    end)

RegisterEventHandler(EventType.LeaveView, "Activate", 
    function(user)
        local mobileObjects = GetViewObjects("Activate")
        if(#mobileObjects == 0) then
            SetPlateActivated(false)
            this:SetObjVar("Activated","false")
            local targetObject = GameObj(tonumber(this:GetObjVar("ExitObjectToMessage")))
            if(targetObject ~= nil) then
                targetObject:SendMessage(this:GetObjVar("SendMessageOnExitView"))
                this:SetHue("AAAAAA")
                this:PlayObjectSound("ScrollUse",false)
            end            
        end
    end)

AddView("Activate", SearchMobileInRange(1.0))

RegisterEventHandler(EventType.Message,"UseObject",
    function(user, usedType)
        if(usedType == "Use") then
            user:PathTo(this:GetLoc(),ServerSettings.Stats.RunSpeedModifier)
        end
    end)