--=============
--version 1.4
--=============
-- *added sequence adjuster for the sequential spawner entries
--=============
--version 1.3
--=============
--  *added a edit button to the loot template
--  *extended the loot tab to insert new item from
--   three fields, template, chance, amount
--  *moved on/off switch to config tab
--	*added Respawn button to Config tab
--	*added Sleep button to Config tab
--	*added Wakeup button to Config tab
--	*updated the spawn list editor to allow you to type
--	 much more into it.
--	*added a edit spawn template button next to each 
--	 spawn entry so you can edit it.
--	*added a edit spawn window to change up the information
--	*for the spawn editor.
--	*added a check box to turn on/off sequential spawning to
--	 the config tab

--=============
--version 1.2
--=============
--  *added the spawner active tab to show you a list of 
--   templates that are ready to be spawned then the
--   spawner wakes up.


--This script was created by Gizmo for public use for the
--legends of aria community. Thank you for using my system.

require 'gizmos_simple_spawner.gizmos_spawner_tooltip'
require 'gizmos_simple_spawner.gizmos_spawner_tables'
require 'gizmos_simple_spawner.gizmos_command_editor_window'
--colors for the menu
local MenuTitleColor = "[CCCC00]"
local TabTextColorActive = "[CCCC00]"
local TabTextColorNonActive = "[888888]"
local QueryTextColor = "[87CEFA]"
local DeleteItemColor = "[FF0000]"
--this is the simple_spawner main user interface
--i made it its own seperate file for ease of use
--the event that captures the interaction is
--located in the gizmos_simple_spawner
function SimpleSpawnerEditWindow(user,spawner,tab,searchtype)
	if(tab == nil) then tab="Spawns" end
	local window = DynamicWindow("EditSpawnerDialog",MenuTitleColor..string.sub(spawner:GetName(),9),600,710,-300,-380,"Default","Center")
	local scrollWindow = ScrollWindow(20,85,540,500,50)
	local spawnColor   = TabTextColorNonActive
	local configColor  = TabTextColorNonActive
	local searchColor  = TabTextColorNonActive
	local lootColor    = TabTextColorNonActive
	local activeColor  = TabTextColorNonActive
	
	if(tab=="Search") then
		scrollWindow = ScrollWindow(20,175,540,480,80)
	end

	if(tab=="Config") then
		scrollWindow = ScrollWindow(20,85,540,300,50)
	end

	if(tab=="Spawns") then spawnColor = TabTextColorActive end
	if(tab=="Config") then configColor = TabTextColorActive end
	if(tab=="Search") then searchColor = TabTextColorActive end
	if(tab=="Loot")   then lootColor = TabTextColorActive end
	if(tab=="Active") then activeColor = TabTextColorActive end


	window:AddLabel(300,4,BuildInformation.TabInfo[tab],400,0,20,"center")
	window:AddButton(33,33,"Spawns:",spawnColor.."Spawns",100,40,"view a list of mobile types the spawner can pick from when randomly spawning",nil,false,"")
	window:AddButton(133,33,"Loot:",lootColor.."Loot",100,40,"view a list of loot that this mob can drop",nil,false,"")
	window:AddButton(233,33,"Active:",activeColor.."Active",100,40,"view a list of currently spawned and active mobiles",nil,false,"")
	window:AddButton(333,33,"Config:",configColor.."Config",100,40,"view a list of objvar that you can modifiy to futher fit your spawn style",nil,false,"")
	window:AddButton(433,33,"Search:",searchColor.."Search",100,40,"view a list of simple spawners found throughout the realm",nil,false,"")

	if(spawner:GetObjVar("active")) then
		if(spawner:GetObjVar("sleeping")) then
			window:AddImage(-41,-47,"Checkbox32px_On",72,72,"","CCCC00")
		else
			window:AddImage(-41,-47,"Checkbox32px_On",72,72,"","008000")
		end
	else
		window:AddImage(-41,-47,"Checkbox32px_Off",72,72,"","800000")
	end

	--this is just a simple show the spawn types
	--and the ability to add and remove the entries
	if(tab == "Spawns") then
		local list = spawner:GetObjVar("templates")
		for i =1, #list do
			local scrollElement = ScrollElement()
			--scrollElement:AddImage(0,0,"SectionBackground",528,50,"Sliced")
			
			scrollElement:AddButton(478,8,"DeleteMobFromList:"..i,DeleteItemColor.."[X]",36,30,"delete "..list[i].. " from the template list",nil,false,"")
			scrollElement:AddButton(432,8,"EditTemplateEntry:"..i,"Edit",46,30,"edit this table entry",nil,true,"")
			if(spawner:GetObjVar("sequential")) then
				if(i == 1) then
					scrollElement:AddButton(5,5,"Nothing"..i,"",55,8,"[FFDD33]this is the top entry","",false,"")
					scrollElement:AddLabel(60,10,QueryTextColor..list[i],385,24,24,"left")					
				end
				if(i >= 2) then
					local presequence = i-1
					scrollElement:AddButton(5,5,"PushEntryUp:"..i,"up",55,8,"[FFDD33]Change To Sequence #[FF7700]"..presequence,"",false,"")
					scrollElement:AddLabel(60,10,QueryTextColor..list[i],385,24,24,"left")
				end
				if(i ~= #list) then
					local postsequence = i + 1
					scrollElement:AddButton(5,25,"PushEntryDown:"..i,"down",55,8,"[FFDD33]Change To Sequence #[FF7700]"..postsequence,"",false,"")
					scrollElement:AddLabel(60,10,QueryTextColor..list[i],385,24,24,"left")
				end
				if(i == #list) then
					scrollElement:AddButton(5,25,"Nothing"..i,"",55,8,"[FFDD33]this is the last entry","",false,"")					
				end				
			else
				scrollElement:AddLabel(10,10,QueryTextColor..list[i],420,24,24,"left")
			end
			scrollWindow:Add(scrollElement)
		end
		window:AddButton(33,600,"AddMobileToList:","Add Entry",100,60,"Adds the template from the textbox to the right of this button",nil,false,"")
		window:AddTextField(133, 600, 400, 60, "template_reference", "")		
	end

	--config table is listed in the gizmos_simple_spawner OnModuleAttach() function
	if(tab=="Config") then
		local list = spawner:GetObjVar("config")
		for i =1, #list do
			local tag = list[i][1]
			local value = list[i][2]
			local scrollElement = ScrollElement()
			--scrollElement:AddImage(0,0,"SectionBackground",528,50,"Sliced")
			scrollElement:AddLabel(10,10,QueryTextColor..tag,340,24,24,"left")
			scrollElement:AddButton(464,8,"EditConfig:"..tag,"Edit",50,30,"modify "..tag.. " from the config list",nil,false,"")
			scrollElement:AddTextField(335,8,125,20,"prop_value_"..tag,tostring(value))
			scrollWindow:Add(scrollElement)
		end	

		window:AddLabel(20,400,"Spawner Name",130,20,20,"left")
		window:AddTextField(155,400,300,20,"spawner_name_value",string.sub(spawner:GetName(),9))
		window:AddButton(465,400,"ChangeName:","Edit",75,20,"modify the name of this spawner",nil,false,"")

		if(spawner:GetObjVar("sequential")) then
   			window:AddButton(20, 440, "SequentialOff:", "", 0, 18, "Turn Sequential Spawning Off", "", false, "Selection","pressed")
   			window:AddLabel(45,440,"Click to turn off sequential spawning",320,20,20,"left")
   			window:AddButton(225,610,"Sleep:","Sleep",100,40,"makes the spawner take a nap",nil,false,"","disabled")
   			window:AddButton(125,610,"Wakeup:","Wakeup",100,40,"makes the spawner wake up from a nap",nil,false,"","disabled")
   			window:AddButton(25,610,"Respawn:","Respawn",100,40,"respawns the spawner, while remembering the sequence count",nil,false,"")
   		else
   			window:AddButton(20, 440, "SequentialOn:", "", 0, 18, "Turn Sequential Spawning On", "", false, "Selection","")
   			window:AddLabel(45,440,"Click to turn on sequential spawning",320,20,20,"left")
   			window:AddButton(225,610,"Sleep:","Sleep",100,40,"makes the spawner take a nap",nil,false,"")
   			window:AddButton(125,610,"Wakeup:","Wakeup",100,40,"makes the spawner wake up from a nap",nil,false,"")   			
   			window:AddButton(25,610,"Respawn:","Respawn",100,40,"respawns the spawner, while remembering the sequence count",nil,false,"")   			
   		end

		--ON/OFF Switch		
		local active = spawner:GetObjVar("active")
		if not (active) then
			window:AddButton(325,610,"Activate:","Turn On",100,40,"Turns on the spawner",nil,false,"")
		else
			window:AddButton(325,610,"Deactivate:","Turn Off",100,40,"Turns off the spawner",nil,false,"")
		end

		window:AddButton(425,610,"CreateIt:","Create Template",150,40,"create a xml script file",nil,false,"")
	end

	--loot table should be {"template","chance","quantity"}
	--template: is the template of the item to spawn as loot
	--chance: this will be in the format of 1 in <chance> chance.. like 1 in 10 or 1 in 100... 10 & 100 would be the chance value
	if(tab=="Loot") then
		local loot = spawner:GetObjVar("loot")
		for i =1, #loot do
			local template = loot[i][1]
			local chance = loot[i][2]
			local quantity = loot[i][3]
			local scrollElement = ScrollElement()
			--scrollElement:AddImage(0,0,"SectionBackground",528,50,"Sliced")
			scrollElement:AddLabel(4,2,QueryTextColor..template,440,26,26,"left")
			scrollElement:AddLabel(4,30,"[CCCC55]1 in "..chance.." chance of appearing as loot with a quantity of "..quantity,440,16,16,"left")
			scrollElement:AddButton(428,8,"EditLootTemplate:"..i,"Edit",48,30,"edit this item",nil,true,"")
			scrollElement:AddButton(478,8,"DeleteLootTemplate:"..i,DeleteItemColor.."[X]",32,30,"delete "..template.. " from the loot template list",nil,false,"")
			scrollWindow:Add(scrollElement)
		end
		window:AddButton(33,635,"AddItemToList:","Insert",100,24,"Adds the loot item to the list format template:chance:quantity",nil,false,"")
		window:AddLabel(138,615,"Template Name",140,18,18,"left")
		window:AddTextField(133, 635, 250, 24, "loot_template", "")

		window:AddLabel(390,615,"Chance",100,18,18,"left")
		window:AddTextField(385, 635, 90, 24, "loot_chance", "1")

		window:AddLabel(490,615,"Amount",100,18,18,"left")
		window:AddTextField(485, 635, 64, 24, "loot_quantity", "1")
	end

	if(tab == "Active") then
		if not(spawner:GetObjVar("active")) then
			local scrollElement = ScrollElement()
			--scrollElement:AddImage(0,0,"SectionBackground",528,50,"Sliced")
			scrollElement:AddLabel(10,10,QueryTextColor.."This spawner is currently not active",480,24,24,"left")
			scrollWindow:Add(scrollElement)
		else
			if not (spawner:GetObjVar("Sleeping")) then
				local list = spawner:GetObjVar("mob_list")
				for i =1, #list do
					local scrollElement = ScrollElement()
					--scrollElement:AddImage(0,0,"SectionBackground",528,50,"Sliced")
					scrollElement:AddLabel(10,10,GameObj(list[i]):GetName().."-"..list[i],340,24,24,"left")
					scrollElement:AddButton(454,8,"SendHome:"..i,"Home",60,30,"sends this mobile back to the spawners x,y,z location",nil,false,"")
					scrollWindow:Add(scrollElement)
				end
			else
				local list = spawner:GetObjVar("reset_list")
				for i =1, #list do
					local scrollElement = ScrollElement()
					--scrollElement:AddImage(0,0,"SectionBackground",528,50,"Sliced")
					scrollElement:AddLabel(10,10,list[i],340,24,24,"left")
					scrollWindow:Add(scrollElement)
				end				
			end
		end
	end

	if(tab=="Search") then
		local searchQuery = ""
		local searchMethod = ""
		local searchString = ""
		if (searchtype ~= nil) then
			searchQuery = StringSplit(searchtype,":")
			searchMethod = searchQuery[1]
			searchString = searchQuery[2]
		end

		if(searchString == nil) then searchString = "" end

		window:AddTextField(32,95,500,30,"query_value","")
		window:AddButton(40,135,"SearchName","Name",80,30,"search for spawners containing the given spawner object name",nil,false,"")
		window:AddButton(120,135,"SearchTemplate","Template",80,30,"search for spawners containing mobile templates",nil,false,"")
		window:AddButton(200,135,"SearchObjectId","ObjectId",80,30,"search for spawners with the given object id value",nil,false,"")
		window:AddButton(280,135,"SearchLootTemp","LootTemp",80,30,"search for spawners containing loot templates",nil,false,"")
		window:AddButton(360,135,"SearchObjVar","ObjVar",80,30,"search for spawners with the given objvar value",nil,false,"")
		window:AddButton(440,135,"SearchTag","Tag",80,30,"search spawners with the config tag value",nil,false,"")

		if(searchMethod == "Name" and searchString ~= "") then
			local spawnerList = FindObjects(SearchObjVar("Gizmos_Search_Function","Don't Change This"))
			if(#spawnerList > 0) then
				for spawnerIndex, spawner in pairs(spawnerList) do
					local OnOff = ""
					if(spawner:GetObjVar("active")) then OnOff = "Turn Off" end
					if not(spawner:GetObjVar("active")) then OnOff = "Turn On" end
					if(string.match(string.lower(spawner:GetName()), string.lower(searchString))) then
						local scrollElement = ScrollElement()
						--scrollElement:AddImage(0,0,"SectionBackground",528,80,"Sliced")
						scrollElement:AddLabel(10,10,QueryTextColor..string.sub(spawner:GetName(),9)..": "..spawner.Id,440,24,24,"left")
						scrollElement:AddButton(7,45,"JumpToSearch:"..spawner.Id,"Jump To",127,30,"",nil,false,"")
						scrollElement:AddButton(134,45,"EditSearch:"..spawner.Id,"Edit",127,30,"",nil,false,"")
						scrollElement:AddButton(261,45,"ActivateSearch:"..spawner.Id.."|"..searchString, OnOff,127,30,"",nil,false,"")							
						scrollWindow:Add(scrollElement)
					end
				end				
			end
		elseif(searchMethod == "Template" and searchString ~= "") then
			local spawnerList = FindObjects(SearchObjVar("Gizmos_Search_Function","Don't Change This"))
			for spawnerIndex, spawner in pairs(spawnerList) do
				local templateList = spawner:GetObjVar("templates")
				if(#templateList > 0) then
					for templateIndex, template in pairs(templateList) do
						if(string.match(string.lower(template), string.lower(searchString))) then
							local scrollElement = ScrollElement()
							--scrollElement:AddImage(0,0,"SectionBackground",528,80,"Sliced")
							scrollElement:AddLabel(10,10,QueryTextColor..string.sub(spawner:GetName(),9)..": "..spawner.Id,440,24,24,"left")
						    scrollElement:AddButton(7,45,"JumpToSearch:"..spawner.Id,"Jump To",127,30,"",nil,false,"")
							scrollElement:AddButton(134,45,"EditSearch:"..spawner.Id,"Edit",127,30,"",nil,false,"")
							scrollElement:AddButton(261,45,"ActivateSearch:"..spawner.Id.."|"..searchString, OnOff,127,30,"",nil,false,"")							
							scrollWindow:Add(scrollElement)
						end
					end				
				end
			end
		elseif(searchMethod == "Id" and searchString ~= "") then
			local spawnerList = FindObjects(SearchObjVar("Gizmos_Search_Function","Don't Change This"))
			for spawnerIndex, spawner in pairs(spawnerList) do
				if(spawner.Id == tonumber(searchString)) then
					local scrollElement = ScrollElement()
					--scrollElement:AddImage(0,0,"SectionBackground",528,80,"Sliced")
					scrollElement:AddLabel(10,10,QueryTextColor..string.sub(spawner:GetName(),9)..": "..spawner.Id,440,24,24,"left")
					scrollElement:AddButton(7,45,"JumpToSearch:"..spawner.Id,"Jump To",127,30,"",nil,false,"")
					scrollElement:AddButton(134,45,"EditSearch:"..spawner.Id,"Edit",127,30,"",nil,false,"")
					scrollElement:AddButton(261,45,"ActivateSearch:"..spawner.Id.."|"..searchString, OnOff,127,30,"",nil,false,"")							
					scrollWindow:Add(scrollElement)
				end
			end
		elseif(searchMethod == "LootTemplate" and searchString ~= "") then
			local spawnerList = FindObjects(SearchObjVar("Gizmos_Search_Function","Don't Change This"))
			for spawnerIndex, spawner in pairs(spawnerList) do
				local templateList = spawner:GetObjVar("loot")
				if(#templateList > 0) then
					for templateIndex, template in pairs(templateList) do
						if(string.match(string.lower(template[1]), string.lower(searchString))) then
							local scrollElement = ScrollElement()
							scrollElement:AddImage(0,0,"SectionBackground",528,80,"Sliced")
							scrollElement:AddLabel(10,10,QueryTextColor..string.sub(spawner:GetName(),9)..": "..spawner.Id,440,24,24,"left")
							scrollElement:AddButton(7,45,"JumpToSearch:"..spawner.Id,"Jump To",127,30,"",nil,false,"")
							scrollElement:AddButton(134,45,"EditSearch:"..spawner.Id,"Edit",127,30,"",nil,false,"")
							scrollElement:AddButton(261,45,"ActivateSearch:"..spawner.Id.."|"..searchString, OnOff,127,30,"",nil,false,"")							
							scrollWindow:Add(scrollElement)
						end
					end				
				end
			end		
		elseif(searchMethod == "ObjVar" and searchString ~= "") then
			local spawnerList = FindObjects(SearchObjVar("Gizmos_Search_Function","Don't Change This"))
			for spawnerIndex, spawner in pairs(spawnerList) do
				if(spawner:HasObjVar(searchString)) then
				local scrollElement = ScrollElement()
					--scrollElement:AddImage(0,0,"SectionBackground",528,80,"Sliced")
					scrollElement:AddLabel(10,10,QueryTextColor..string.sub(spawner:GetName(),9)..": "..spawner.Id,440,24,24,"left")
					scrollElement:AddButton(7,45,"JumpToSearch:"..spawner.Id,"Jump To",127,30,"",nil,false,"")
					scrollElement:AddButton(134,45,"EditSearch:"..spawner.Id,"Edit",127,30,"",nil,false,"")
					scrollElement:AddButton(261,45,"ActivateSearch:"..spawner.Id.."|"..searchString, OnOff,127,30,"",nil,false,"")							
					scrollWindow:Add(scrollElement)
				end
			end		
		elseif(searchMethod == "Tag" and searchString ~= "") then
			local spawnerList = FindObjects(SearchObjVar("Gizmos_Search_Function","Don't Change This"))
			for spawnerIndex, spawner in pairs(spawnerList) do
				local tag = spawner:GetObjVar("spawner_tag")
				if(string.match(string.lower(tag), string.lower(searchString))) then
					local scrollElement = ScrollElement()
					--scrollElement:AddImage(0,0,"SectionBackground",528,80,"Sliced")
					scrollElement:AddLabel(10,10,QueryTextColor..string.sub(spawner:GetName(),9)..": "..spawner.Id,440,24,24,"left")
					scrollElement:AddButton(7,45,"JumpToSearch:"..spawner.Id,"Jump To",127,30,"",nil,false,"")
					scrollElement:AddButton(134,45,"EditSearch:"..spawner.Id,"Edit",127,30,"",nil,false,"")
					scrollElement:AddButton(261,45,"ActivateSearch:"..spawner.Id.."|"..searchString, OnOff,127,30,"",nil,false,"")							
					scrollWindow:Add(scrollElement)
				end
			end
		end
	end
	window:AddScrollWindow(scrollWindow)
	user:OpenDynamicWindow(window,spawner)
end


