require 'default:player'

--version 1.3
--  removed version 1.1 handlepickup and went
--  a different approach.

--version 1.1
--	added HandlePickUpOfItem(pickedUpObject) so when a
--  player picks up a object they will tell the
--  spawner to remove the item from mob_list so
--  it is avalible to respawn again
------------------------------------------------
-- simple spawner system
------------------------------------------------


--****************************************************************************
--REMOVE THIS FUNCTION OR COMMENT IT OUT IN THE OLD PRE 1.3 player.lua SCRIPT
--****************************************************************************
-- function HandlePickUpOfItem(pickedUpObject)
-- 	if(pickedUpObject:HasObjVar("parentSpawner")) then
-- 		GameObj(pickedUpObject:GetObjVar("parentSpawner")):SendMessage("mobHasDied", pickedUpObject)
-- 	end
-- 	HandleRequestPickUp(pickedUpObject)
-- end

-- RegisterEventHandler(EventType.RequestPickUp, "", HandlePickUpOfItem)



--****************************************************************************
--This function fixes a issue in the old system. make sure you copy this function
--HandleRequestPickUp(pickedUpObject) to your player.lua file. We will using
--this function from now on to handle spawner items being picked up.
--****************************************************************************
function HandleRequestPickUp(pickedUpObject)

	--DebugMessage("Tried to pick up "..pickedUpObject:GetName())
	local carriedObject = this:CarriedObject()
	if( carriedObject ~= nil and carriedObject:IsValid() ) then
		this:SystemMessage("You are already carrying something.","info")
		this:SendPickupFailed(pickedUpObject)
		return
	end

	if not(CanPickUp(pickedUpObject)) then
		this:SendPickupFailed(pickedUpObject)
		return
	end
	--DebugMessage("Pick up here")
	this:SendMessage("BreakInvisEffect")
	--GIZMO EDIT
	--for when a player picks up a item from a spawner
	--it tells the spawner it has been taken
	if(pickedUpObject:HasObjVar("parentSpawner")) then
		GameObj(pickedUpObject:GetObjVar("parentSpawner")):SendMessage("mobHasDied", pickedUpObject)
	end
	--END GIZMO EDIT
	-- keep track of the source location so we can undo the pickup
	local sourceContainer = pickedUpObject:ContainedBy()
	local sourceTopmost = pickedUpObject:TopmostContainer() or sourceContainer
	local sourceLoc = pickedUpObject:GetLoc()
	local sourceEquipSlot = nil
	local equipSlot = GetEquipSlot(pickedUpObject)
	--check to see if the containers have noloot on them
	if (sourceContainer ~= nil) then 
		if (sourceContainer:HasObjVar("noloot") and (IsDemiGod(this) == false)) then
			this:SystemMessage("You can't pick that up.","info")
			this:SendPickupFailed(pickedUpObject)
			return
		end
		--DebugMessage("source container: "..sourceContainer:GetName())
		--DebugMessage("sourceTopmost = "..tostring(sourceContainer:TopmostContainer()))
		--DebugMessage("this name = "..tostring(this:GetName()))
		--[[DebugMessage("GROUP CHECK: ",
			Group.Get(this) ~= nil,
			Group.CheckAutoloot(Group.Get(this)),
			sourceTopmost ~= this,
			sourceContainer:IsMobile(),
			sourceContainer:HasObjVar("Reward"),
			not sourceContainer:HasObjVar("PrivateLoot"),
			"OUTCOME: ",
			((sourceContainer:IsMobile() and not sourceContainer:HasObjVar("PrivateLoot")) or sourceContainer:HasObjVar("Reward")))--]]
		if (Group.Get(this) ~= nil 			
			and Group.CheckAutoloot(Group.Get(this))
			and sourceTopmost ~= this
			and ((sourceTopmost:IsMobile() and (not sourceTopmost:HasObjVar("PrivateLoot")) and not pickedUpObject:IsEquipped()) or sourceTopmost:HasObjVar("Reward")) ) then
			this:SystemMessage("[$2403]","info")
			this:SendPickupFailed(pickedUpObject)
			return
		end
	end

	CheckNotorietyLoot(pickedUpObject, this)
	if sourceTopmost ~= nil then
		if sourceTopmost:HasObjVar("noloot") and (IsDemiGod(this) == false) then
			this:SystemMessage("You can't pick that up.","info")
			this:SendPickupFailed(pickedUpObject)
			return
		end

	end	

	if(equipSlot ~= nil and this:GetEquippedObject(equipSlot) == pickedUpObject) then
		sourceEquipSlot = equipSlot
	end

	if( pickedUpObject:MoveToContainer(this,Loc(0,0,0)) ) then
		if(pickedUpObject:HasModule("decay")) then
			pickedUpObject:DelModule("decay")
			pickedUpObject:DelObjVar("DecayTime")
		end		

		carriedObjectSource = sourceContainer
		carriedObjectSourceLoc = sourceLoc
		carriedObjectSourceEquipSlot = sourceEquipSlot
		if(sourceEquipSlot ~= nil) then
			pickedUpObject:SendMessage("WasUnequipped", this)
		end
	end
end

